VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "GenericForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' this is a class file for a VB form bot; edit all sections
' marked with "CHANGE" comments
Option Explicit

' ===================================================================
' CHANGE: edit the following strings as appropriate for your bot
Const sName = "GenericForm"
Const sDescription = "I am a generic form handling bot"
' ===================================================================

' the following declarations apply for all FORM bots
Const sKind = "form"  ' declare that we are a FORM bot
Const sTag = ""       ' not used for FORM bots
Const sPreview = ""   ' not used by FORM bots

' these three dictionaries are passed in from FrontPage
Private attrs As Dictionary, cgi As Dictionary, formvals As Dictionary
' this is the property editing dialog for the Edit method
Private editor As Form

Private Sub Class_Initialize()
    ' ===========================================================
    ' CHANGE: edit this to point at your property editing form
    Set editor = frmGenericForm
    ' ===========================================================
End Sub

Private Sub Class_Terminate()
    ' always have an error handler in Terminate method
    On Error Resume Next
    
    ' release dictionary references
    Set attrs = Nothing
    Set cgi = Nothing
    Set formvals = Nothing
    
    ' release form reference
    Set editor = Nothing
End Sub

Public Property Get Name() As String
    ' return the bot's name (same as class name)
    Name = sName
End Property

Public Property Get Kind() As String
    ' return the kind of bot we are: either "insert" or "form"
    Kind = sKind
End Property

Public Property Get Tag() As String
    ' return the HTML tag context for this bot;
    ' this method is only used for "insert" bots
    Tag = sTag
End Property

Public Property Get Description() As String
    ' return a brief description of what the bot does
    Description = sDescription
End Property

Public Property Get Preview() As String
    ' return a chunk of HTML that represents the bot in the Editor;
    ' this method is only called for Insert bots, not Form bots
    Preview = sPreview
End Property

Public Sub Load(dictBot As Dictionary, dictCgi As Dictionary, dictForm As Dictionary)
    ' receive references to dictionaries filled in by FrontPage
    Set attrs = dictBot
    Set cgi = dictCgi
    Set formvals = dictForm
End Sub

Public Function Expand() As String

    ' ====================================================
    ' CHANGE: edit this method as appropriate for your bot
    ' ====================================================
    
    ' called when containing page is saved, recalced,
    ' fetched via SHTML interpreter, or has a form submitted to it

    Dim sHTML As String    ' build HTML output string here
    Dim sHeaders As String ' build MIME headers here (each ending with vbLf)
    Dim sMethod As String  ' either "Expand" (GET) or "Evaluate" (POST)
    Dim sParse As String   ' either "Static" (Recalc) or "Dynamic" (SHTML)
    
    Dim Key As Variant
    
    Expand = ""            ' set default return value: no output
    
    ' figure out why this bot is being expanded
    sMethod = attrs("method")
    sParse = attrs("parse")
    
    ' see FrontPage SDK for documentation of all the built-in
    ' bot attributes: method, parse, pageurl, documentroot,
    ' weburl, basedocurl
    
    ' most form bots only do something when a form is submitted
    If sMethod = "Expand" Or sParse = "Static" Then Exit Function

    ' if we get to here, a form has been submitted to us;
    ' values are in 'formvals' dictionary
    
    ' add MIME header to indicate we are generating a new page;
    ' see the FrontPage SDK documentation for other MIME headers
    sHeaders = sHeaders & "Content-Type: text/html" & vbLf
    
    ' generate HTML output
    sHTML = sHTML & "<html>" & vbLf
    sHTML = sHTML & "<head>" & vbLf
    sHTML = sHTML & "<title>" & Name & " Form Results" & "</title>" & vbLf
    sHTML = sHTML & "</head>" & vbLf
    sHTML = sHTML & "<body>" & vbLf
    sHTML = sHTML & "<h1>Form Results</h1>" & vbLf
    sHTML = sHTML & "<hr>" & vbLf
    sHTML = sHTML & "<p>Thank you for submitting the following information:</p>" & vbLf
    sHTML = sHTML & "<ul>" & vbLf
    For Each Key In formvals
        sHTML = sHTML & "<li>" & Key & "=" & formvals(Key) & "</li>" & vbLf
    Next
    sHTML = sHTML & "</ul>" & vbLf
    sHTML = sHTML & "</body>" & vbLf
    sHTML = sHTML & "</html>" & vbLf
    
    ' assemble headers (if any) and HTML into output string
    
    If Len(sHeaders) > 0 Then
        ' important: there must be a blank line after any headers
        Expand = sHeaders & vbLf & sHTML
    Else
        ' always put a newline before the returned string
        ' if there are no headers (this is required if the
        ' output HTML contains newline chars)
        Expand = vbLf & sHTML
    End If
    
End Function

Public Function Edit() As Boolean

    ' DO NOT EDIT this method; everything interesting
    ' should be done in your custom editor form

    ' give the dialog a reference to this bot object
    Set editor.bot = Me
    ' give the dialog a reference to bot's private attribute dictionary
    Set editor.dictAttrs = attrs
      
    ' display the dialog
    editor.Show vbModal
    
    ' when dialog returns, see if changes were made,
    ' and pass that info back to caller
    If attrs.Exists("_EDIT_OK") Then
        Edit = True
        attrs.Remove ("_EDIT_OK")
    Else
        Edit = False
    End If

End Function



