VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "GenericInsert"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' this is a class file for a VB insert bot; edit all sections
' marked with "CHANGE" comments
Option Explicit

' ===================================================================
' CHANGE: edit the following strings as appropriate for your bot
Const sName = "GenericInsert"
Const sDescription = "I am a generic insert bot"
' declare the tag context where this bot is allowed (ex: "body")
Const sTag = "body"
' declare the HTML used to represent this bot in the Editor
' (or construct it dynamically in the Preview method below);
' this *MUST* be consistent with the tag context above!
Const sPreview = "<h3>" & sName & "</h3>"
' ===================================================================

' the following declaration applies for all INSERT bots
Const sKind = "insert"  ' declare that we are an INSERT bot

' these three dictionaries are passed in from FrontPage
Private attrs As Dictionary, cgi As Dictionary, formvals As Dictionary
' this is the property editing dialog for the Edit method
Private editor As Form

Private Sub Class_Initialize()
    ' ===========================================================
    ' CHANGE: edit this to point at your property editing form
    Set editor = frmGenericInsert
    ' ===========================================================
End Sub

Private Sub Class_Terminate()
    ' always have an error handler in Terminate method
    On Error Resume Next
    
    ' release dictionary references
    Set attrs = Nothing
    Set cgi = Nothing
    Set formvals = Nothing
    
    ' release form reference
    Set editor = Nothing
End Sub

Public Property Get Name() As String
    ' return the bot's name (same as class name)
    Name = sName
End Property

Public Property Get Kind() As String
    ' return the kind of bot we are: either "insert" or "form"
    Kind = sKind
End Property

Public Property Get Tag() As String
    ' return the HTML tag context for this bot;
    ' this method is only used for "insert" bots
    Tag = sTag
End Property

Public Property Get Description() As String
    ' return a brief description of what the bot does
    Description = sDescription
End Property

Public Property Get Preview() As String
    ' return a chunk of HTML that represents the bot in the Editor;
    ' this method is only used for "insert" bots
    Preview = sPreview
End Property

Public Sub Load(dictBot As Dictionary, dictCgi As Dictionary, dictForm As Dictionary)
    ' receive references to dictionaries filled in by FrontPage
    Set attrs = dictBot
    Set cgi = dictCgi
    Set formvals = dictForm
End Sub

Public Function Expand() As String

    ' ====================================================
    ' CHANGE: edit this method as appropriate for your bot
    ' ====================================================

    ' called when containing page is saved, recalced,
    ' fetched via SHTML interpreter, or has a form submitted to it

    Dim sMethod As String  ' either "Expand" (GET) or "Evaluate" (POST)
    Dim sParse As String   ' either "Static" (Recalc) or "Dynamic" (SHTML)
    
    ' figure out why this bot is being expanded
    sMethod = attrs("method")
    sParse = attrs("parse")
    
    ' see FrontPage SDK for documentation of all the built-in
    ' bot attributes: method, parse, pageurl, documentroot,
    ' weburl, basedocurl
   
    ' now create HTML output
    
    Dim s As String
    Dim Key As Variant
    
    s = s & "<h1>Default VB Bot Expansion</h1>"
    
    If attrs.Count > 0 Then
        s = s & "<h3>Bot Attributes</h3>"
        s = s & "<ul>"
        For Each Key In attrs
            s = s & "<li>" & Key & "=" & attrs(Key) & "</li>"
        Next
        s = s & "</ul>"
    End If
    
    If formvals.Count > 0 Then
        s = s & "<h3>Form Values</h3>"
        s = s & "<ul>"
        For Each Key In formvals
            s = s & "<li>" & Key & "=" & formvals(Key) & "</li>"
        Next
        s = s & "</ul>"
    End If
    
    If cgi.Count > 0 Then
        s = s & "<h3>CGI Environment</h3>"
        s = s & "<ul>"
        For Each Key In cgi
            s = s & "<li>" & Key & "=" & cgi(Key) & "</li>"
        Next
        s = s & "</ul>"
    End If

    ' always put a newline before the returned string
    ' if there are no headers (this is required if the
    ' output HTML contains newline chars)
    Expand = vbLf & s
    
End Function

Public Function Edit() As Boolean

    ' DO NOT EDIT this method; everything interesting
    ' should be done in your custom editor form
    
    ' give the dialog a reference to this bot object
    Set editor.bot = Me
    ' give the dialog a reference to bot's private attribute dictionary
    Set editor.dictAttrs = attrs
      
    ' display the dialog
    editor.Show vbModal
    
    ' when dialog returns, see if changes were made,
    ' and pass that info back to caller
    If attrs.Exists("_EDIT_OK") Then
        Edit = True
        attrs.Remove ("_EDIT_OK")
    Else
        Edit = False
    End If

End Function

