//
// Copyright (c) 1998 Microsoft Corp.  All Rights Reserved
//
// File: vbtest.cpp
// 
// Defines two custom FrontPage bots that interface to all VB bots.
//

#include "stdafx.h"
#include "vbtest.h"
#include "vbtestdialog.h"
#include "../webbot.h"
#include "vbwebbot.h"
#include "scrrun.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CvbtestApp

BEGIN_MESSAGE_MAP(CvbtestApp, CWinApp)
	//{{AFX_MSG_MAP(CvbtestApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CvbtestApp construction

CvbtestApp::CvbtestApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CvbtestApp object


CvbtestApp theApp;

////////////////////////////////////////////////////////
// implementation for Expand method of all VB bots

void GenericExpand(
	CWebBotString& ret,
	CWebBotDict& botAttribs,
	CWebBotDict& cgi,
	CWebBotDict& form)
{                                                   
	CoInitialize(NULL);

	CString szClass, szRes;
	szClass = botAttribs.GetValue("S-Class");
	szRes = "[vbbot]";

	_VBbot obj;
	COleException err; 
	if(obj.CreateDispatch(szClass,&err))
	{
		COleVariant varName;
		COleVariant varVal;

		CString szKey;
		CString szVal;
		const char *pKey = NULL;

		IDictionary dictBot;
		IDictionary dictCgi;
		IDictionary dictForm;

		COleException err; 
		if(!dictBot.CreateDispatch("Scripting.Dictionary",&err))
			return;
		if(!dictCgi.CreateDispatch("Scripting.Dictionary",&err))
			return;
		if(!dictForm.CreateDispatch("Scripting.Dictionary",&err))
			return;

		while(pKey = botAttribs.NextKey())
		{
			varName.SetString(pKey,VT_BSTR);
			szVal = botAttribs.GetValue(pKey);
			varVal.SetString(szVal,VT_BSTR);

			dictBot.Add((LPVARIANT)varName,(LPVARIANT)varVal);
		}

		while(pKey = cgi.NextKey())
		{
			varName.SetString(pKey,VT_BSTR);
			szVal = cgi.GetValue(pKey);
			varVal.SetString(szVal,VT_BSTR);

			dictCgi.Add((LPVARIANT)varName,(LPVARIANT)varVal);
		}

		while(pKey = form.NextKey())
		{
			varName.SetString(pKey,VT_BSTR);
			szVal = form.GetValue(pKey);
			varVal.SetString(szVal,VT_BSTR);

			dictForm.Add((LPVARIANT)varName,(LPVARIANT)varVal);
		}

		obj.Load(&dictBot.m_lpDispatch, &dictCgi.m_lpDispatch, &dictForm.m_lpDispatch);

		szRes = obj.Expand();

		obj.ReleaseDispatch();

		// copy dictionary back into bot

		COleVariant varKeys = dictBot.Keys();
		COleVariant varItems = dictBot.Items();
		SAFEARRAY * psaKeys = (varKeys.vt & VT_BYREF) ? *(varKeys.pparray) : varKeys.parray;
		SAFEARRAY * psaItems = (varItems.vt & VT_BYREF) ? *(varItems.pparray) : varItems.parray;

		long lLBound;
		SafeArrayGetLBound(psaKeys,1,&lLBound);
		long lUBound;
		SafeArrayGetUBound(psaItems,1,&lUBound);

		for(long idx = lLBound; idx <= lUBound; idx++)
		{
			SafeArrayGetElement(psaKeys, &idx, &varName);
			SafeArrayGetElement(psaItems, &idx, &varVal);
			varName.ChangeType(VT_BSTR);
			varVal.ChangeType(VT_BSTR);
			if(varName.vt == VT_BSTR && varVal.vt == VT_BSTR)
			{
				szKey = varName.bstrVal;
				szVal = varVal.bstrVal;
				botAttribs.SetValue(szKey, szVal);
			}
		}
	}
	else
	{
		szRes.Format("<b>[ VBbot error: unable to create object from class %s (code 0x%lx) ]</b>",
			szClass,(long)err.m_sc);
	}

	ret.Append(szRes);

	CoUninitialize();
}

////////////////////////////////////////////////////////
// implementation for Edit method of all VB bots

int GenericEdit(
	CWebBotDict& botAttribs,
	LPCTSTR pszKind)
{
	CString szKind(pszKind); // "insert" or "form"

	CString szClass = botAttribs.GetValue("S-Class");

	if(szClass.IsEmpty())
	{
		// let users pick the VB bot they want

		TCHAR chName[256];
		DWORD nchName = 256;
		DWORD idx = 0;
		CString szName;
		CString szPattern("Webbot.");
		int nPat = szPattern.GetLength();
		CStringArray saBots;

		while(RegEnumKeyEx(HKEY_CLASSES_ROOT, idx, chName, &nchName, NULL, NULL, NULL, NULL) 
			!= ERROR_NO_MORE_ITEMS)
		{
			szName = chName;
			if(szName.Left(nPat) == szPattern)
			{
				// filter the list so only szKind bots are shown
				_VBbot obj;
				COleException err; 
				if(obj.CreateDispatch(szName,&err))
				{
					CString szBotKind = obj.GetKind();
					obj.ReleaseDispatch();
					if(szBotKind.CompareNoCase(szKind) == 0)
						saBots.Add(szName);
				}
			}
			nchName = 256;
			idx++;
		}

		CvbtestDialog dlg;
		dlg.m_saClasses.Copy(saBots);

		int nResponse = dlg.DoModal();
		if(nResponse != IDOK)
			return FALSE;
		
		szClass = dlg.m_szSelectedClass;
		botAttribs.SetValue("S-Class", dlg.m_szSelectedClass);

		if(szKind.CompareNoCase("insert") == 0)
		{
			botAttribs.SetValue("TAG", dlg.m_szTag);
			botAttribs.SetValue("PREVIEW", dlg.m_szPreview);
		}
	}
	
	// load dictionary, call VB edit method, 
	// get values back

	IDictionary dictBot;
	IDictionary dictCgi;
	IDictionary dictForm;

	COleException err; 
	if(!dictBot.CreateDispatch("Scripting.Dictionary",&err))
		return FALSE;
	if(!dictCgi.CreateDispatch("Scripting.Dictionary",&err))
		return FALSE;
	if(!dictForm.CreateDispatch("Scripting.Dictionary",&err))
		return FALSE;

	COleVariant varName;
	COleVariant varVal;

	CString szKey;
	CString szVal;
	const char *pKey = NULL;

	while(pKey = botAttribs.NextKey())
	{
		varName.SetString(pKey,VT_BSTR);
		szVal = botAttribs.GetValue(pKey);
		varVal.SetString(szVal,VT_BSTR);

		dictBot.Add((LPVARIANT)varName,(LPVARIANT)varVal);
	}

	BOOL bRet = FALSE;

	_VBbot obj;
	if(obj.CreateDispatch(szClass,&err))
	{
		obj.Load(&dictBot.m_lpDispatch, &dictCgi.m_lpDispatch, &dictForm.m_lpDispatch);
		bRet = obj.Edit();

		if(bRet)
		{
			// copy dictionary back into bot

			COleVariant varKeys = dictBot.Keys();
			COleVariant varItems = dictBot.Items();
			SAFEARRAY * psaKeys = (varKeys.vt & VT_BYREF) ? *(varKeys.pparray) : varKeys.parray;
			SAFEARRAY * psaItems = (varItems.vt & VT_BYREF) ? *(varItems.pparray) : varItems.parray;

			long lLBound;
			SafeArrayGetLBound(psaKeys,1,&lLBound);
			long lUBound;
			SafeArrayGetUBound(psaItems,1,&lUBound);

			for(long idx = lLBound; idx <= lUBound; idx++)
			{
				SafeArrayGetElement(psaKeys, &idx, &varName);
				SafeArrayGetElement(psaItems, &idx, &varVal);
				varName.ChangeType(VT_BSTR);
				varVal.ChangeType(VT_BSTR);
				if(varName.vt == VT_BSTR && varVal.vt == VT_BSTR)
				{
					szKey = varName.bstrVal;
					szVal = varVal.bstrVal;
					botAttribs.SetValue(szKey, szVal);
				}
			}
		}

		obj.ReleaseDispatch();
	}
	else
	{
		CString szMsg;
		szMsg.Format("Unable to create object from class %s (code 0x%lx)",
			szClass,(long)err.m_sc);
		CString szCaption("VBbot error");

		::MessageBox(NULL,szMsg,szCaption,MB_OK | MB_ICONEXCLAMATION);
	}

	return bRet;
}

/////////////////////////////
// vbinsert bot

BeginWebBotExpand(vbinsert,ret,botAttribs,cgi,form)
{
	GenericExpand(ret,botAttribs,cgi,form);
}
EndWebBotExpand


BeginWebBotEdit(vbinsert, botAttribs)
{
	return GenericEdit(botAttribs, "insert");
}
EndWebBotEdit

/////////////////////////////
// vbform bot

BeginWebBotExpand(vbform,ret,botAttribs,cgi,form)
{
	GenericExpand(ret,botAttribs,cgi,form);
}
EndWebBotExpand


BeginWebBotEdit(vbform, botAttribs)
{
	return GenericEdit(botAttribs, "form");
}
EndWebBotEdit
