//
// Copyright (c) 1996 Vermeer Technologies, Inc., a wholly owned
//               subsidiary of Microsoft Corp.  All Rights Reserved
//
// File: vbtestDialog.cpp
// Dialog Implementation File
//

#include "stdafx.h"
#include "vbtest.h"
#include "vbtestDialog.h"
#include "vbwebbot.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CvbtestDialog dialog


CvbtestDialog::CvbtestDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CvbtestDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CvbtestDialog)
	m_szDescription = _T("");
	//}}AFX_DATA_INIT
}


void CvbtestDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CvbtestDialog)
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Control(pDX, IDC_VBCLASS, m_lbClass);
	DDX_Text(pDX, IDC_VBDESC, m_szDescription);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CvbtestDialog, CDialog)
	//{{AFX_MSG_MAP(CvbtestDialog)
	ON_LBN_SELCHANGE(IDC_VBCLASS, OnSelchangeVbclass)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CvbtestDialog message handlers

BOOL CvbtestDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	for(int i=0; i<m_saClasses.GetSize(); i++)
	{
		m_lbClass.AddString(m_saClasses[i]);
	}

	m_szTag = m_szDescription = "";

	m_btnOK.EnableWindow(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CvbtestDialog::OnSelchangeVbclass() 
{
	int idx = m_lbClass.GetCurSel();
	if(idx < 0) 
	{
		m_btnOK.EnableWindow(FALSE);
		return;
	}
	
	CString szClass;
	m_lbClass.GetText(idx,szClass);

	_VBbot obj;
	COleException err; 
	if(obj.CreateDispatch(szClass,&err))
	{
		m_szTag = obj.GetTag();
		m_szDescription = obj.GetDescription();
		m_szPreview = obj.GetPreview();
		UpdateData(FALSE);
		obj.ReleaseDispatch();
		m_btnOK.EnableWindow(TRUE);
		m_szSelectedClass = szClass;
	}
	else
	{
		m_btnOK.EnableWindow(FALSE);
		m_szSelectedClass.Empty();
	}
}
