//
// Copyright (c) 1999 Microsoft Corp.  All Rights Reserved
//
// File: VoteBotDialog.cpp
// Dialog Implementation File
//

#include "stdafx.h"
#include "votebot.h"
#include "VoteBotDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// VoteBotDialog dialog


VoteBotDialog::VoteBotDialog(CWnd* pParent /*=NULL*/)
	: CDialog(VoteBotDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(VoteBotDialog)
	m_ConfirmPercent = FALSE;
	m_ConfirmTotal = FALSE;
	m_ConfirmTotalEach = FALSE;
	m_ConfirmMessage = _T("");
	//}}AFX_DATA_INIT
	m_ConfirmMessage = "Thank you for your input!";
	m_bModified = FALSE;
	m_bFirstEdit = FALSE;   // assume this is NOT the first time bot has been edited
	m_voteopt = 0;
}


void VoteBotDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(VoteBotDialog)
	DDX_Check(pDX, IDC_ConfirmPercent, m_ConfirmPercent);
	DDX_Check(pDX, IDC_ConfirmTotal, m_ConfirmTotal);
	DDX_Check(pDX, IDC_ConfirmTotalEach, m_ConfirmTotalEach);
	DDX_Text(pDX, IDC_MSG, m_ConfirmMessage);
	//}}AFX_DATA_MAP
	DDX_Radio(pDX, IDC_YESNO, m_voteopt);
	//what's the problem??!!!
}


BEGIN_MESSAGE_MAP(VoteBotDialog, CDialog)
	//{{AFX_MSG_MAP(VoteBotDialog)
	ON_BN_CLICKED(IDC_ConfirmPercent, setModFlag)
	ON_BN_CLICKED(IDC_AGREE, setModFlag)
	ON_BN_CLICKED(IDC_ConfirmTotal, setModFlag)
	ON_BN_CLICKED(IDC_ConfirmTotalEach, setModFlag)
	ON_BN_CLICKED(IDC_FORAGAINST, setModFlag)
	ON_EN_CHANGE(IDC_MSG, setModFlag)
	ON_BN_CLICKED(IDC_YESNO, setModFlag)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void VoteBotDialog::DialogToDictionary(CWebBotDict &dict)
{
	// read values from editor ui into corresopnding botdict values

	// map confirmtype (ConfirmTotal)
		if (m_ConfirmTotal==0)
		{	dict.SetValue("B-CONFIRMTOTAL", "FALSE");	}
		else if (m_ConfirmTotal==1)
		{	dict.SetValue("B-CONFIRMTOTAL", "TRUE");};

	// map confirmtype (ConfirmPercent)
		if (m_ConfirmPercent==0)
		{	dict.SetValue("B-CONFIRMPERCENT", "FALSE");	}
		else if (m_ConfirmPercent==1)
		{	dict.SetValue("B-CONFIRMPERCENT", "TRUE");};

	// map confirmtype (ConfirmTotalEach)
		if (m_ConfirmTotalEach==0)
		{	dict.SetValue("B-CONFIRMTOTALEACH", "FALSE");	}
		else if (m_ConfirmTotalEach==1)
		{	dict.SetValue("B-CONFIRMTOTALEACH", "TRUE");};

	// map voteopt (yes/no, agree/disagree, for/against)
	// Get current value of S-VOTEOPT attribute.  If it has changed, we know we'll
	// have to reformat/reset the results file
		CString sztemp = dict.GetValue("S-VOTEOPT");  

		if (m_voteopt==0)
		{	if (sztemp=="YES/NO") { dict.SetValue("B-REFORMAT", "FALSE");  }
			else
			{	dict.SetValue("S-VOTEOPT", "YES/NO"); dict.SetValue("B-REFORMAT", "TRUE");}
		}
		else if (m_voteopt==1)
		{	if (sztemp=="AGREE") { dict.SetValue("B-REFORMAT", "FALSE");  }
			else
			{	dict.SetValue("S-VOTEOPT", "AGREE"); dict.SetValue("B-REFORMAT", "TRUE"); }
		}
		else if (m_voteopt==2)
		{	if (sztemp=="FOR/AGAINST") { dict.SetValue("B-REFORMAT", "FALSE");  }
			else
			{	dict.SetValue("S-VOTEOPT", "FOR/AGAINST"); dict.SetValue("B-REFORMAT", "TRUE"); }
		}

	// map confirmation message (S-CONFIRMMSG)
		dict.SetValue("S-CONFIRMMSG", m_ConfirmMessage);
}

void VoteBotDialog::DictionaryToDialog(CWebBotDict &dict)
{   

	// read bot params from dictionary and map to component editor dialog

    // cast dict.GetValue so we can use it in a comparison
	// and get voteopt attribute from botdict
	CString sztemp = dict.GetValue("S-VOTEOPT");

	if (sztemp=="YES/NO")
	{	m_voteopt = 0;	}
	else if (sztemp=="AGREE")
	{	m_voteopt = 1;	}
	else if (sztemp=="FOR/AGAINST")
	{	m_voteopt = 2;	}
		else 
	{	m_bFirstEdit = TRUE;	};   // First time bot has been inserted
	
	// get value of ConfirmTotal from botdict
	sztemp = dict.GetValue("B-CONFIRMTOTAL");
 	// get votetype attribute from botdict
	if (sztemp=="FALSE")
	{	m_ConfirmTotal = 0; }
	else if (sztemp=="TRUE") 
	{	m_ConfirmTotal = 1;	};
	
	// get value of ConfirmPercent from botdict
	sztemp = dict.GetValue("B-CONFIRMPERCENT");
 	// get votetype attribute from botdict
	if (sztemp=="FALSE")
	{	m_ConfirmPercent = 0; }
	else if (sztemp=="TRUE") 
	{	m_ConfirmPercent = 1;	};

	// get value of ConfirmTotalEach from botdict
	sztemp = dict.GetValue("B-CONFIRMTOTALEACH");
 	// get votetype attribute from botdict
	if (sztemp=="FALSE")
	{	m_ConfirmTotalEach = 0; }
	else if (sztemp=="TRUE") 
	{	m_ConfirmTotalEach = 1;	};

	if (m_bFirstEdit) 
	{ dict.SetValue("SuggestedExt", "asp");
	  dict.SetValue("S-CONFIRMMSG", "Thank you for your input!");
	  dict.SetValue("BOTID", ""); }
	
	m_ConfirmMessage = dict.GetValue("S-CONFIRMMSG");
}

/////////////////////////////////////////////////////////////////////////////
// VoteBotDialog message handlers

void VoteBotDialog::setModFlag() 
{
	// TODO: Add your control notification handler code here
	m_bModified = TRUE;
	
}
