//
// Copyright (c) 1999 Microsoft Corp.  All Rights Reserved
//
// File: votebot.cpp
// Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "votebot.h"
#include "votecount.h"
#include "votefile.h"
#include <afxisapi.h>  // defines path_info server var
#include "VoteBotDialog.h"
#include "webbot.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CvotebotApp

BEGIN_MESSAGE_MAP(CvotebotApp, CWinApp)
	//{{AFX_MSG_MAP(CvotebotApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CvotebotApp construction

CvotebotApp::CvotebotApp()
{
	
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CvotebotApp object

CvotebotApp theApp;

/////////////////////////////////////////////////////////////////////////////
// Routines needed for returning the voting options related to, and creating
// a preview based on, this particular voting component

void ReturnMappedVoteOptions (CWebBotDict &bot, char* sVoteType1, char* sVoteType2)
{
	
	const char* sztemp; // temp variable
	sztemp = bot.GetValue("S-VOTEOPT");

	if (!strcmp(sztemp,"YES/NO"))
	{	strcpy(sVoteType1,"Yes"); strcpy(sVoteType2,"No");	}
	else if (!strcmp(sztemp,"AGREE"))
	{	strcpy(sVoteType1,"I Agree"); strcpy(sVoteType2,"I Disagree");	}
	else if (!strcmp(sztemp,"FOR/AGAINST"))
	{	strcpy(sVoteType1,"For"); strcpy(sVoteType2,"Against");	};
}

/////////////////////////////////////////////////////////////////////////////
char* CreatePreview(CWebBotDict &bot)
{
	
	char* PreviewBuffer = new char[1000];
	char* sVoteType1 = new char[15];
	char* sVoteType2 = new char[15];

	ReturnMappedVoteOptions (bot, sVoteType1, sVoteType2);
	
	//strcpy(PreviewBuffer, "<div align=\"center\">");
	strcpy(PreviewBuffer, "<center>");
	strcat(PreviewBuffer, "<table border=\"0\" width=\"67%\">");
    strcat(PreviewBuffer, "<tr>");
    strcat(PreviewBuffer, "<td width=\"100%\">");
    strcat(PreviewBuffer, "<p align=\"center\"><input type=\"radio\">");
	strcat(PreviewBuffer, sVoteType1);
	strcat(PreviewBuffer, ".&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
	strcat(PreviewBuffer, "<input type=\"radio\">");
	strcat(PreviewBuffer, sVoteType2);
    strcat(PreviewBuffer, ".</p>");
    strcat(PreviewBuffer, "<p align=\"center\"><input type=\"button\" value=\"Submit my vote!\">&nbsp;</p>");
    strcat(PreviewBuffer, "</td></tr></table></center>");
	//strcat(PreviewBuffer, "</div>");

		
	delete[] sVoteType1;
	delete[] sVoteType2;

	return PreviewBuffer;
}

/////////////////////////////////////////////////////////////////////
// DLL Entry point for editing the WebBot

BeginWebBotEdit(aspvoter, bot)
{
	// define the component editor dialog
	VoteBotDialog dlg;
	
	// get current bot values from dictionary 
	dlg.DictionaryToDialog(bot);
	int nResponse = dlg.DoModal();
	
	// put new bot values back into dictionary
	dlg.DialogToDictionary(bot);
	char* Preview = CreatePreview(bot);
	
	bot.SetValue("PREVIEW", Preview);
	bot.SetValue("SuggestedExt", "asp");
	bot.SetValue("TAG","BODY");
	
	delete[] Preview;
	return ((dlg.m_bModified || dlg.m_bFirstEdit) && (nResponse == IDOK));

}
EndWebBotEdit

/////////////////////////////////////////////////////////////////////
// DLL Entry point for expanding the WebBot

BeginWebBotExpand(aspvoter,ret,bot,cgi,form)
{
	// cgi and form are unused, so they are commented out to prevent compiler
	// warnings.
    (void)cgi;
    (void)form;

	char* sVoteType1 = new char[15];
	char* sVoteType2 = new char[15];
	
	// Take care of the vote count file
	ReturnMappedVoteOptions (bot, sVoteType1, sVoteType2);
    HandleVoteCntFile(bot, sVoteType1, sVoteType2);

    const char* iBotID = bot.GetValue("BOTID");
		
	// Generate the PageDirName
    const char *PageURL = bot.GetValue("PageURL");
    if (!PageURL)
        PageURL = "";

    ret.Clear();

    // Put in the MIME Links: header so that the explorer knows
    // that our WebBot is linking to the vote count file.  That is, append
    // Links: WebURL/_private/PageURL.vot, URL encoding the filename
    
	ret.Append("Links: ");
    ret.Append(bot.GetValue("WebURL"));
	ret.Append("/_private/");
	char *EncodedPageFileName = URLEncode(PageURL,
                                          URLTranslateFrom,
                                          URLTranslateTo,
                                          URLNumTranslations);
    ret.Append(EncodedPageFileName);
    ret.Append(iBotID);
	ret.Append(".vot");

    // Put in the MIME WriteLinks: header so that the explorer knows
    // that our WebBot is writing to the vote count file.  This will cause  
	// the server extensions to set the permissions on this
	// file so that browsers can write to it.  
    // WriteLinks: WebURL/_private/PageURL.vot.  

	ret.Append("\nWriteLinks: ");
	ret.Append(bot.GetValue("WebURL"));
	ret.Append("/_private/");
	ret.Append(EncodedPageFileName);
	ret.Append(iBotID);
	ret.Append(".vot");	
	
	// Put in the MIME Error: header to signify any setup errors

	const char *sztype = bot.GetValue("S-VOTETYPE");
	if (!sztype)
        ret.Append("\nError: A voting component is incorrectly configured.  "
                   "You must provide values for the component's \"S-VOTETYPE\" "
                   "parameter.");
	
	// a blank like signifies the end of all MIME headers:
	
	ret.Append("\n\n");

	// stick the ASP out there...

	ret.Append("<%\n"); 
    
	//ret.Append("Dim bVoteConfirm\n");
    
	ret.Append("bOptionFound = FALSE    ' specifies whether or not we have a matching Vote option\n");
	ret.Append("CurrentVoteCount = 0    ' number of votes matching the one most recently submitted\n");
	ret.Append("iNumVotes = Array(0,0)  ' array holding the number of each type of vote\n");
	ret.Append("Set fs = CreateObject(\"Scripting.FileSystemObject\")\n");
	
	ret.Append("sVoteFilePath=\"");
	ret.Append(bot.GetValue("U-votepath"));
	ret.Append("\"\n");
    
	ret.Append("bVoteConfirm = not(request.form(\"voteopt\") = \"\")\n");
		
	ret.Append("\nSub ManageVoteResults");
	ret.Append(iBotID);
	ret.Append("\n"); 
	
	ret.Append("' Handles the tallying and increment of the vote results file\n");
	ret.Append("    bOptionFound = FALSE  ' Set to true when a matching Vote option is found\n");
	ret.Append("	Set InFile  = fs.OpenTextFile(sVoteFilePath, 1, FALSE, FALSE)\n");
	ret.Append("	Infile.ReadLine      ' skip the FILE-DESCRIPTOR line\n");
	ret.Append("	iNumVotesIndex = 0\n");
	ret.Append("	Do while not(InFile.AtEndOfStream)\n");
	ret.Append("		rString = InFile.ReadLine\n");
	ret.Append("		If rString <> \"\" Then\n"); 
	
	ret.Append("			lengthVoteString = len(Request.Form(\"voteopt\"))\n");
	ret.Append("			iColonLocale = Instr(rString, \":\")\n");
	ret.Append("			iNumVotes(iNumVotesIndex)=right(rString,len(rString) - iColonLocale ) \n"); 
	
	ret.Append("			If (left(rString,lengthVoteString) = Request.Form(\"voteopt\")) Then\n"); 
	ret.Append("				iNumVotes(iNumVotesIndex) = iNumVotes(iNumVotesIndex) + 1\n");
	ret.Append("				CurrentVoteCount = iNumVotes(iNumVotesIndex)\n");
	
	ret.Append("				bOptionFound = TRUE\n");
	
	// TODO: add check for "is INT?" at this spot in ASP script

	ret.Append("			End If \n");
	ret.Append("		Else \n");
	ret.Append("			Response.write(\"<p>ERROR: Invalid Voting Results File.\")\n");
	ret.Append("		End If\n");
	ret.Append("		iNumVotesIndex = iNumVotesIndex + 1 \n"); 
	ret.Append("	Loop \n");
	ret.Append("	InFile.Close \n");
	
	// append bot-specific CreateVoteFile func name
	ret.Append("	CreateVoteFile");
	ret.Append(iBotID);
	ret.Append(" iNumVotes(0), iNumVotes(1) \n");
	ret.Append("End Sub \n\n");

	ret.Append("Function CreateVoteFile");
	ret.Append(iBotID);
	ret.Append(" (iNumVotes1, iNumVotes2)\n");
	ret.Append("' (Re)Creates the VoteFile\n");
	
	ret.Append("	CreateFolderNested(ReturnBaseUrl(sVoteFilePath))\n");
	ret.Append("	Set InFile = fs.CreateTextFile(sVoteFilePath, True)\n");
	ret.Append("	Infile.WriteLine(\"Voting Results for file '\" & sPathInfo & \"':\")\n");
	ret.Append("	InFile.WriteLine(\"");
	ret.Append(sVoteType1);
	ret.Append(":\" & iNumVotes1)\n");
	ret.Append("	InFile.WriteLine(\"");
	ret.Append(sVoteType2);
	ret.Append(":\" & iNumVotes2)\n");
	ret.Append("	InFile.Close\n");
	ret.Append("End Function\n\n");

	ret.Append("Function CreateFolderNested (sPath)\n");
	ret.Append("' Creates the directory structure sPath one level at a time\n");
	
	ret.Append("	if (fs.FolderExists(sPath)) Then\n");
	
	ret.Append("		CreateFolderNested = sPath\n");
	ret.Append("	Else \n");
	ret.Append("		CreateFolderNested(ReturnBaseUrl(sPath))\n");
	
	ret.Append("		fs.CreateFolder(sPath)\n");
	ret.Append("	End If \n");
	ret.Append("End Function \n\n");

	ret.Append("Function ReturnBaseUrl(sFilePath)\n");
	ret.Append("' This function returns a URL that equals sFilePath with everything\n");
	ret.Append("' after the trailing / snipped\n");
	ret.Append("	For x = len(sFilePath) to 1 step -1 \n");
	ret.Append("		if mid(sFilePath, x, 1) = \"\\\" Then \n");
	ret.Append("			x = x - 1 \n");
	ret.Append("			Exit For \n");
	ret.Append("		End If \n");
	ret.Append("	Next \n");
	ret.Append("	ReturnBaseUrl = left(sFilePath, x ) \n");
	ret.Append("End Function \n");

	ret.Append("\n' Main\n");
	ret.Append("   if (not(bVoteConfirm)) or (not(request.form(\"index\")=");
	ret.Append(iBotID);
	ret.Append(")) Then \n");
	ret.Append("	   if not(fs.FileExists(sVoteFilePath)) Then CreateVoteFile");
	ret.Append(iBotID);
	ret.Append(" 0,0\n");
	ret.Append("                    ' Create the file to hold vote results, if necessary %>\n");
	
	ret.Append("<form method=\"POST\" action=\"<%=Request.ServerVariables(\"PATH_INFO\")%>\">\n");
    
	ret.Append("  <div align=\"center\"><center>\n");
    ret.Append("  <strong><input type=\"radio\" value=\"");
	ret.Append(sVoteType1);	
	ret.Append("\" checked name=\"voteopt\">");
	ret.Append(sVoteType1);
	ret.Append(".\n");
    ret.Append("  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <input type=\"radio\""); 
	ret.Append(" value=\"");
	ret.Append(sVoteType2);	
	ret.Append("\" name=\"voteopt\">");
	ret.Append(sVoteType2);
	ret.Append(". </strong></p>\n");
    ret.Append("  </center></div><div align=\"center\"><center><p><input type=\"submit\"\n");
	ret.Append("      value=\"Submit my ballot!\" name=\"B1\"> \n");
	
	// Send this component's 'BOTID' to serverside handler via a hidden field
	ret.Append("      <input type=\"hidden\" name=\"index\" value=\"");
	ret.Append(iBotID);
	ret.Append("\"> \n");

    ret.Append("  </center></div>\n");
    ret.Append("</form>\n");
	ret.Append("<% else if (bVoteConfirm) Then \n");
	ret.Append("		  if not(fs.FileExists(sVoteFilePath)) Then CreateVoteFile");
	ret.Append(iBotID);
	ret.Append(" 0,0\n");
	ret.Append("                    ' Create the file to hold vote results, if necessary \n");
	ret.Append("          ManageVoteResults");
	ret.Append(iBotID);
	ret.Append("\n");		 
	ret.Append("        	 if not(bOptionFound) Then ManageVoteResults");
	ret.Append(iBotID);
	ret.Append("\n");
	ret.Append("					' if we didn't find matching vote option the first\n");
    ret.Append("                    ' time, search once more with re-initialized file. %> \n");
	
	
	ret.Append("<p align=\"center\"><strong>");
	ret.Append(bot.GetValue("S-CONFIRMMSG"));
	ret.Append("<br>\n");
    
	const char* sztemp = bot.GetValue("B-CONFIRMTOTAL");

	if (!strcmp(sztemp,"TRUE"))
	{   ret.Append("Thus far, there have been ");
		ret.Append("<% response.Write(iNumVotes(0) + iNumVotes(1)) %>");
		ret.Append(" ballots cast.<br>\n"); }
		
	sztemp = bot.GetValue("B-CONFIRMPERCENT");

	if (!strcmp(sztemp,"TRUE"))
	{   ret.Append("<% response.write((100 * CurrentVoteCount) \\ (iNumVotes(0) + iNumVotes(1))) %>");
		ret.Append("% of the Voting Population agrees with your vote. <br>\n"); }
	
	sztemp = bot.GetValue("B-CONFIRMTOTALEACH");
	
	if (!strcmp(sztemp,"TRUE"))
	{   ret.Append("<% response.write(iNumVotes(0))%> votes for \"");
		ret.Append(sVoteType1);
		ret.Append("\", <%response.write(iNumVotes(1))%> votes for \"");
		ret.Append(sVoteType2);
		ret.Append("\".<br>\n");
	}
	
	ret.Append("    </strong>\n");
	ret.Append("<%     End If\n"); 
	ret.Append("  End If %>\n");
	
	delete[] EncodedPageFileName;
	delete[] sVoteType1;
	delete[] sVoteType2;
	
}
EndWebBotExpand




