//
// Copyright (c) 1999 Microsoft Corp.  All Rights Reserved

///// Misc. File utilities

#include "stdafx.h"
#include "resource.h"
#include <string.h>


BOOL IsDir(CString dir)
{
    DWORD attributes = GetFileAttributes(dir);

    // Error getting file attributes, return false assuming it's
    // non-existance that's causing the problem
    if (attributes == 0xFFFFFFFF)
            return FALSE;
    // Now check if what's there is actually a directory
    if ((attributes & FILE_ATTRIBUTE_DIRECTORY) == FILE_ATTRIBUTE_DIRECTORY)
            return TRUE;

    return FALSE;
}

BOOL MyCreateDir(LPCTSTR dir)
{
	if (IsDir(dir))
		return TRUE;				// Already exists

	if (!CreateDirectory(dir, NULL))
	{
		CString errMsg;
		AfxFormatString1(errMsg, IDS_CANNOT_CREATE_DIR, dir);
		AfxMessageBox(errMsg);
		return FALSE;
	}
	return TRUE;
}

BOOL MyCopyFile(CString filename, CString destDir)
{
	// The false at the end means succeed if the file already exists
	if (!CopyFile(filename, destDir + "\\" + filename, FALSE))
	{
		DWORD ErrorNum = GetLastError();
		CString errMsg;
		switch (ErrorNum)
		{
			case 2: 
				AfxFormatString2(errMsg, IDS_CANNOT_COPY_ERROR2, filename, destDir);
				break;
			case 5:
				AfxFormatString2(errMsg, IDS_CANNOT_COPY_EXISTS, filename, destDir);
				break;
			case 14:
				AfxFormatString2(errMsg, IDS_CANNOT_COPY_ERROR3, filename, destDir);
				break;
			default: AfxFormatString2(errMsg, IDS_CANNOT_COPY_FILE, filename, destDir);
		}
		AfxMessageBox(errMsg);
		return FALSE;
	}
	return TRUE;
}

BOOL FullyCreateDirectory(CString dir)
{
	if (IsDir(dir))
		return TRUE;				// Already exists

	int length = dir.GetLength();
	char *buffer = new char[length + 1];
	strcpy(buffer, dir);
	buffer[length] = '\0';

	for (int index = dir.Find(':') + 2; index < length; index++)
	{
		if (buffer[index] == '\\')
		{
			buffer[index] = '\0';
			if (!MyCreateDir(buffer))
				return FALSE;
			buffer[index] = '\\';
		}
	}
	// Just a quick double check... this IsDir should succeed.  If it
	// doesn't, I don't know what's wrong so just try creating the
	// whole thing and display the error message if it fails
	if (!IsDir(dir))
		return MyCreateDir(dir);
	else
		return TRUE;	
}
