//
// Copyright (c) 1999 Microsoft Corp.  All Rights Reserved

#include "stdafx.h"
#include "pwssrv.h"
#include "winreg.h"
#include "fileutil.h"


CString CMSPWSServer::GetDocumentRoot()
{
	return GetMSPWSVirtRoot("/");	
}

CString CMSPWSServer::GetCgiBinDir()
{
	// we don't create a cgi-bin dir for fp99 on iis
	//return GetMSPWSVirtRoot("/cgi-bin");	
	return (m_DocumentRoot + "\\cgi-bin");
}

CString CMSPWSServer::GetBotDir()
{
	return (m_DocumentRoot + "\\_vti_bot");	
}

CString CMSPWSServer::GetMSPWSVirtRoot(CString dir)
{
	HKEY rootKey;
	// Open HKEY_LOCAL_MACHINE\System\CurrentControlSet\...
	long result = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Services\\W3SVC\\Parameters\\Virtual Roots",
					0, KEY_QUERY_VALUE, &rootKey);

	if (result != ERROR_SUCCESS)
		return "";


	DWORD Type;
	BYTE Data[MAX_PATH];
	DWORD chData = MAX_PATH;
	
    // Try finding MS PWS value
	result = RegQueryValueEx(rootKey, dir, NULL, &Type, Data, &chData);
    if (result != ERROR_SUCCESS)
        // Try finding MS IIS value
        result = RegQueryValueEx(rootKey, dir + ",", NULL, &Type, Data, &chData);

	if (result == ERROR_SUCCESS && Type == REG_SZ)
	{
		// We got a value.  It's in the form path,username,access.
		// So just return up to the first comma.
		for (UINT i=0; i < chData; i++)
		{
			if (Data[i] == ',')
			{
				Data[i] = '\0';
				break;
			}
		}
		return CString(Data);
	}
	else
		return "";

}
