//
// Copyright (c) 1999 Microsoft Corp.  All Rights Reserved

//////////////////////////////////////////////////////
// CServer.cpp
//
// Defines CServer base class

#include "stdafx.h"
#include "server.h"
#include "resource.h"
#include "fileutil.h"


CServer::CServer()
{
	m_bInstallable = FALSE;
}


BOOL CServer::IsInstallable()
{	
    // This program always installs the bots in the _vti_bot directory of the
    // web server's root directory.  (For a multi-hosted MS IIS server, this
    // means only the default root.)

    // Another way to install the bot would be to install it in the bots
    // directory in the FrontPage install directory.  See the FrontPage
    // SDK documentation for more details.

	m_DocumentRoot = GetDocumentRoot();
	m_CgiBinDir = GetCgiBinDir();
	m_BotDir = GetBotDir();

	if (m_DocumentRoot.IsEmpty() || m_BotDir.IsEmpty())
		m_bInstallable = FALSE;
	else
		m_bInstallable = TRUE;

	return m_bInstallable;
}


BOOL CServer::Install(BOOL versionASP)
{
	if (!m_bInstallable)
		return FALSE;

	if (!MyCreateDir(m_BotDir))
		return FALSE;
	
	if ((!versionASP) && (!MyCreateDir(m_CgiBinDir)))
		return FALSE;

	CString specificBotDir;
	if (versionASP)	{	specificBotDir = m_BotDir + "\\aspvoter";	}
	else {	specificBotDir = m_BotDir + "\\votebot";	}

	if (!MyCreateDir(specificBotDir))
		return FALSE;

	if (versionASP)
	{	
		if (!MyCopyFile("aspvoter.inf", specificBotDir))
			return FALSE;
		if (!MyCopyFile("aspvoter.dll", specificBotDir))
			return FALSE;
	}

	else
	{	
		if (!MyCopyFile("votebot.inf", specificBotDir))
			return FALSE;
		if (!MyCopyFile("votesrvr.dll", specificBotDir))
			return FALSE;
		if (!MyCopyFile("votebot.exe", m_CgiBinDir))
			return FALSE;
		if (!MyCopyFile("votebot.dll", specificBotDir))
			return FALSE;
	}
	
	return TRUE;
}
